	INCLUDE EFR32MG12.inc		; CPU register definitions
	INCLUDE	terminal.inc		
	EXPORT	main
	IMPORT	GPIO_setup		; import names from other code files
	IMPORT	RTCC_setup	

RED_LED		EQU	8
GREEN_LED	EQU	9	

;-------------------------------------	; CODE segment in flash (ROM) 
	AREA    |.text|, CODE, READONLY
main	PROC				; main user code
	bl	Terminal_setup
	bl	GPIO_setup		; configure port pins
	bl	RTCC_setup

	ldr	R0, =prompt
	bl	WriteString		; print a prompt
	bl	ReadHex			; get user input (hhmmss)

	ldr	R1, =RTCC
	str	R0, [R1, #RTCC_TIME]	; set time in RTCC
	
loop					; print time with 1sec period
	GETW	RTCC_IF, RTCC		; R1 = RTCC flags
	ands	R1, #(1<<5)		; check for CNTTICK flag
	beq	loop
	PUTW	1<<5, RTCC_IFC		; clear flag

	bl	printTime
	b	loop			; loop back	
	ENDP

;-------------------------------------
printTime	PROC
	push	{LR, R0-R2}		; save used regs
	GETW	RTCC_TIME, RTCC		; R1 = time
	lsr	R0, R1, #20		; R0 = HOURT
	add	R0, #'0'		; ASCII conversion
	bl	WriteChar		; print tens of hours
	
	lsr	R0, R1, #16		; R0 = HOURU
	and	R0, #0x0F
	add	R0, #'0'		; ASCII conversion
	bl	WriteChar		; print units of hours	
	
	mov	R0, #':'			
	bl	WriteChar
	
	lsr	R0, R1, #12		; R0 = MINT
	and	R0, #0x0F
	add	R0, #'0'		; ASCII conversion
	bl	WriteChar		; print tens of minutes
	
	lsr	R0, R1, #8		; R0 = MINU
	and	R0, #0x0F
	add	R0, #'0'		; ASCII conversion
	bl	WriteChar		; print units of minutes	
	
	mov	R0, #':'			
	bl	WriteChar
	
	lsr	R0, R1, #4		; R0 = SECT
	and	R0, #0x0F
	add	R0, #'0'		; ASCII conversion
	bl	WriteChar		; print tens of seconds

	and	R0, R1, #0x0F		; R0 = SECU
	add	R0, #'0'		; ASCII conversion
	bl	WriteChar		; print units of seconds
	bl	NewLine
	pop	{PC, R0-R2}		; restire regs and return
	ENDP

;-----------------------------------
prompt	DCB	"Enter time (hhmmss): ", 0

	ALIGN
	END